/****************************************
Sample V4L2 program for saving settings
for Sentech cameras

Marius Silaghi msilaghi@fit.edu
 ***************************************/

#include <sys/ioctl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <linux/videodev2.h>
#include <Sentech/sentech.h>

int fd, result;

int main(int argc, char**argv) {
  int opt;
  int op=0, ob=0;
  const char*filename = "/dev/video";
  struct sentech_settings ss;

  if (argc == 1) {
      fprintf(stderr, "Usage: %s [-d device] [-c] [-r | -w | -i] [-s | -p]\n",
	      argv[0]);
      exit(EXIT_FAILURE);
  }
  while ((opt = getopt(argc, argv, "rwispcd:")) != -1) {
    switch (opt) {
    case 'd': filename =  optarg; break;
    case 'c': break;
    case 'r': op = SENTECH_SETTINGS_SAVING_OPP_READ; break;
    case 'w': op = SENTECH_SETTINGS_SAVING_OPP_WRITE; break;
    case 'i': op = SENTECH_SETTINGS_SAVING_OPP_RESET; break;
    case 'p': ob = SENTECH_SETTINGS_SAVING_OBJ_PIX_BC; break;
    case 's': ob = SENTECH_SETTINGS_SAVING_OBJ_CAMERA; break;
    default: /* '?' */
      fprintf(stderr, "Usage: %s [-c] [-d device]  [-r] [-w] [-i] [-s] [-p]\n",
	      argv[0]);
      exit(EXIT_FAILURE);
    }
  }

  fd = open(filename,O_RDONLY);
  if (fd < 0){
    perror("open");
    exit(2);
  }
  ss.operation = op;
  ss.object = ob;
    
  result = ioctl(fd, SENTECH_IOC_SAVE_SETTINGS, &ss);
  if (result != 0) {
    perror("ioctl setttings");
    exit(2);
  }
}
