#ifndef SENTECH_AWB
__attribute__((always_inline)) inline void
gen_line_grey_sentech_indir(struct sentech_camera * UNUSED(cam_data),
		      __u8* frame , char *data,
		      int  UNUSED(scan_width) , int wmax ,
		      int wstart , int  UNUSED(h) ,
		      const __u8 *  UNUSED(crt_gamma),
		      int  UNUSED(scan_height), int wratio) {
  int w, sw=0;
  int line_start = 0;
  char *p=data;
  for (w=line_start+wstart;sw<wmax;sw++,w+=wratio) {
    *p = frame[w];
    p++;
  }
}
__attribute__((always_inline)) inline void
gen_line_bgr24_vmalloc_indir(struct sentech_camera *cam_data,
	       __u8* frame , char *data,
	       int scan_width , int wmax ,
	       int wstart , int h ,
	       const __u8 * crt_gamma,
	       int scan_height, int UNUSED(rows), int wratio,
	       int hasprev, int evenh) {
  int brightness = cam_data->brightness;
  int red = cam_data->red, green = cam_data->green, blue = cam_data->blue;
  int w, w_idx;
  int line_start = 0, line_prev = -scan_width, line_next = scan_width;
  char *p=data;
  int src_ptr;
  int pix_prev, pix_next;
  int wmax_abs = (wmax>>1)-1;
;
  if(unlikely(!hasprev)) line_prev = line_next;
  else if(unlikely(h==(scan_height-1))) line_next = line_prev;
  w = wstart&(~1);
  src_ptr = line_start+w;
  pix_prev = w-1; pix_next = w+1;
  if(!w)
    pix_prev = pix_next;
  interpolateRGBg(p+2, p+1, p,
		    frame, brightness,
		    line_prev, pix_prev,
		    line_next, pix_next,
		    src_ptr, line_start, w,
		  red, green, blue,
		    evenh, 1, crt_gamma, cam_data);    
  p+=3;
  w+=wratio;
  src_ptr+=wratio;
  pix_prev = w-1;
  pix_next = w+1;
  if(likely(wratio&1)){ 
    if(evenh) {
      for (w_idx=0;w_idx<wmax_abs;w_idx++) {
	interpolateRGBg(p+2, p+1, p,
			  frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  1, 0, crt_gamma, cam_data);    
	p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
	interpolateRGBg(p+2, p+1, p,
			frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  1, 1, crt_gamma, cam_data);    
      p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
      }
    }else{
      for (w_idx=0;w_idx<wmax_abs;w_idx++) {
	interpolateRGBg(p+2, p+1, p,
			  frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  0, 0, crt_gamma, cam_data);    
	p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
	interpolateRGBg(p+2, p+1, p,
			  frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  0, 1, crt_gamma, cam_data);    
      p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
      }
    }
  } else {
    if(evenh) {
      for (w_idx=0;w_idx<wmax_abs;w_idx++) {
	interpolateRGBg(p+2, p+1, p,
			  frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  1, 1, crt_gamma, cam_data);    
	p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
	interpolateRGBg(p+2, p+1, p,
			frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  1, 1, crt_gamma, cam_data);    
      p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
      }
    }else{
      for (w_idx=0;w_idx<wmax_abs;w_idx++) {
	interpolateRGBg(p+2, p+1, p,
			  frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  0, 1, crt_gamma, cam_data);    
	p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
	interpolateRGBg(p+2, p+1, p,
			  frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  0, 1, crt_gamma, cam_data);    
      p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
      }
    }
  }
  if(likely(w==(scan_width-1)))
    pix_next = pix_prev;
  interpolateRGBg(p+2, p+1, p,
		    frame, brightness,
		    line_prev, pix_prev,
		    line_next, pix_next,
		    src_ptr, line_start, w,
		  red, green, blue,
		    evenh, !(wratio&1), crt_gamma, cam_data);    
  p+=3;
;
}
__attribute__((always_inline)) inline void
gen_line_rgb24_vmalloc_indir(struct sentech_camera *cam_data,
	       __u8* frame , char *data,
	       int scan_width , int wmax ,
	       int wstart , int h ,
	       const __u8 * crt_gamma,
	       int scan_height, int UNUSED(rows), int wratio,
	       int hasprev, int evenh) {
  int brightness = cam_data->brightness;
  int red = cam_data->red, green = cam_data->green, blue = cam_data->blue;
  int w, w_idx;
  int line_start = 0, line_prev = -scan_width, line_next = scan_width;
  char *p=data;
  int src_ptr;
  int pix_prev, pix_next;
  int wmax_abs = (wmax>>1)-1;
;
  if(unlikely(!hasprev)) line_prev = line_next;
  else if(unlikely(h==(scan_height-1))) line_next = line_prev;
  w = wstart&(~1);
  src_ptr = line_start+w;
  pix_prev = w-1; pix_next = w+1;
  if(!w)
    pix_prev = pix_next;
  interpolateRGBg(p, p+1, p+2,
		    frame, brightness,
		    line_prev, pix_prev,
		    line_next, pix_next,
		    src_ptr, line_start, w,
		  red, green, blue,
		    evenh, 1, crt_gamma, cam_data);    
  p+=3;
  w+=wratio;
  src_ptr+=wratio;
  pix_prev = w-1;
  pix_next = w+1;
  if(likely(wratio&1)){ 
    if(evenh) {
      for (w_idx=0;w_idx<wmax_abs;w_idx++) {
	interpolateRGBg(p, p+1, p+2,
			  frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  1, 0, crt_gamma, cam_data);    
	p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
	interpolateRGBg(p, p+1, p+2,
			frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  1, 1, crt_gamma, cam_data);    
      p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
      }
    }else{
      for (w_idx=0;w_idx<wmax_abs;w_idx++) {
	interpolateRGBg(p, p+1, p+2,
			  frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  0, 0, crt_gamma, cam_data);    
	p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
	interpolateRGBg(p, p+1, p+2,
			  frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  0, 1, crt_gamma, cam_data);    
      p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
      }
    }
  } else {
    if(evenh) {
      for (w_idx=0;w_idx<wmax_abs;w_idx++) {
	interpolateRGBg(p, p+1, p+2,
			  frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  1, 1, crt_gamma, cam_data);    
	p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
	interpolateRGBg(p, p+1, p+2,
			frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  1, 1, crt_gamma, cam_data);    
      p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
      }
    }else{
      for (w_idx=0;w_idx<wmax_abs;w_idx++) {
	interpolateRGBg(p, p+1, p+2,
			  frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  0, 1, crt_gamma, cam_data);    
	p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
	interpolateRGBg(p, p+1, p+2,
			  frame, brightness,
			  line_prev, pix_prev,
			  line_next, pix_next,
			  src_ptr, line_start, w,
		  red, green, blue,
			  0, 1, crt_gamma, cam_data);    
      p+=3;
	w+=wratio;
	src_ptr+=wratio;
	pix_prev = w-1;
	pix_next = w+1;
      }
    }
  }
  if(likely(w==(scan_width-1)))
    pix_next = pix_prev;
  interpolateRGBg(p, p+1, p+2,
		    frame, brightness,
		    line_prev, pix_prev,
		    line_next, pix_next,
		    src_ptr, line_start, w,
		  red, green, blue,
		    evenh, !(wratio&1), crt_gamma, cam_data);    
  p+=3;
;
}
__attribute__((always_inline)) inline void
gen_line_yuv420_vmalloc_indir(struct sentech_camera *cam_data,
		__u8* frame , char *data,
		int scan_width , int wmax ,
		int wstart , int h ,
		const __u8 * crt_gamma,
		char *dataU,
		char *dataV, int scan_height,
			int rows, int wratio) {
  int  evenh, evenw;
  int brightness = cam_data->brightness;
  int red = cam_data->red, green = cam_data->green, blue = cam_data->blue;
  int w_idx, w; 
  int line_start = 0, line_prev = -scan_width, line_next = scan_width;
  __u8 R, G, B;
  __u8 Y, U, V;
  __u16 U16, V16;
  int src_ptr;
  int pix_prev, pix_next;
  int wmax1 = scan_width-1;
  if(unlikely(!h)) line_prev = line_next;
  else if(unlikely(h==(scan_height-1))) line_next = line_prev;
  evenh = !(h & 1);
  for (w_idx=0, w=wstart; w_idx<wmax; w+=wratio, w_idx++) {
    src_ptr = line_start+w;
    pix_prev = w-1; pix_next = w+1;
    if(!w) {pix_prev = pix_next;}
    else if(w == wmax1) {pix_next=pix_prev;}
    evenw = !(w & 1);    
    interpolateRGBg(&R, &G, &B,
		    frame, brightness,
		    line_prev, pix_prev,
		    line_next, pix_next,
		    src_ptr, line_start, w,
		    red, green, blue,
		   evenh, evenw, crt_gamma, cam_data);    
    Y = TO_Y(R,G,B);
    *data = Y;
    data++;
    if((1 & rows & w_idx)) {
      U16=TO_U(R,G,B);
      *dataU = (*dataU + U16)>>1;
      dataU++;
      V16=TO_V(R,G,B);
      *dataV = (*dataV + V16)>>1;
      dataV++;
    }else
      if(!(1 & (rows | w_idx))) {
	U=TO_U(R,G,B);
	*dataU = U; dataU++;
	V=TO_V(R,G,B);
	*dataV = V; dataV++;
      }
  }
}
__attribute__((always_inline)) inline void
gen_line_yuv422P_vmalloc_indir(struct sentech_camera *cam_data,
		__u8* frame , char *data,
		int scan_width , int wmax ,
		int wstart , int h ,
		const __u8 * crt_gamma,
		char *dataU,
		char *dataV, int scan_height,
			int rows, int wratio) {
  int  evenh, evenw;
  int brightness = cam_data->brightness;
  int red = cam_data->red, green = cam_data->green, blue = cam_data->blue;
  int w_idx, w; 
  int line_start = 0, line_prev = -scan_width, line_next = scan_width;
  __u8 R, G, B;
  __u8 Y, U, V;
  __u16 U16, V16;
  int src_ptr;
  int pix_prev, pix_next;
  int wmax1 = scan_width-1;
  if(unlikely(!h)) line_prev = line_next;
  else if(unlikely(h==(scan_height-1))) line_next = line_prev;
  evenh = !(h & 1);
  for (w_idx=0, w=wstart; w_idx<wmax; w+=wratio, w_idx++) {
    src_ptr = line_start+w;
    pix_prev = w-1; pix_next = w+1;
    if(!w) {pix_prev = pix_next;}
    else if(w == wmax1) {pix_next=pix_prev;}
    evenw = !(w & 1);    
    interpolateRGBg(&R, &G, &B,
		    frame, brightness,
		    line_prev, pix_prev,
		    line_next, pix_next,
		    src_ptr, line_start, w,
		    red, green, blue,
		   evenh, evenw, crt_gamma, cam_data);    
    Y = TO_Y(R,G,B);
    *data = Y;
    data++;
    if((1 & w_idx)){
      U16=TO_U(R,G,B);
      *dataU = (*dataU + U16)>>1;
      dataU++;
      V16=TO_V(R,G,B);
      *dataV = (*dataV + V16)>>1;
      dataV++;
    }else{
      U=TO_U(R,G,B);
      *dataU = U;
      V=TO_V(R,G,B);
      *dataV = V;
    }
  }
}
__attribute__((always_inline)) inline void
gen_line_y16_vmalloc_indir(struct sentech_camera *cam_data,
	      __u8* frame , char *data,
	      int scan_width , int wmax ,
	      int wstart , int h ,
	      const __u8 * crt_gamma,
	      int scan_height) {
  int w, wmax_abs;
  int line_start = 0;
  char *p=data;
  wmax_abs = line_start+wmax+wstart;
  for (w=line_start+wstart;w<wmax_abs;w++) {
    *p = frame[w];
    p++;
    *p = frame[w];
    p++;
  }
}
__attribute__((always_inline)) inline void
gen_line_yuyv_vmalloc_indir(struct sentech_camera *cam_data,
		      __u8* frame , char *data,
		      int scan_width , int wmax ,
		      int wstart , int h ,
		      const __u8 * crt_gamma,
		      int scan_height, int rows, int wratio) {
  int  evenh, evenw;
  int brightness = cam_data->brightness;
  int red = cam_data->red, green = cam_data->green, blue = cam_data->blue;
  int w, w_idx;
  int line_start = 0, line_prev = -scan_width, line_next = scan_width;
  __u8 R, G, B;
  __u8 Y, U, V;
  char *p=data;
  int src_ptr;
  int pix_prev, pix_next;
  int wmax1 = wstart+wmax-1;
  if(unlikely(!h)) line_prev = line_next;
  else if(unlikely(h==(scan_height-1))) line_next = line_prev;
  evenh = !(h & 1);
  for (w=wstart,w_idx=0;w_idx<wmax;w+=wratio,w_idx++) {
    src_ptr = line_start+w;
    pix_prev = w-1; pix_next = w+1;
    if(!w) {pix_prev = pix_next;}
    else if(w == wmax1) {pix_next=pix_prev;}
    evenw = !(w & 1);
    interpolateRGBg(&R, &G, &B,
		    frame, brightness,
		    line_prev, pix_prev,
		    line_next, pix_next,
		    src_ptr, line_start, w,
		    red, green, blue,
		    evenh, evenw, crt_gamma, cam_data);    
    Y = TO_Y(R,G,B);
    *p = Y;
    p++;
    if(w_idx&1){
      V=TO_V(R,G,B);
      *p = V;
    }else{
      U=TO_U(R,G,B);
      *p = U;
    }
    p++;
  }
}
static int
indirect_move_to_vmalloc(struct sentech_camera* cam_data, int _idx) {
  __u8* data = cam_data->sib.vmalloc_vbuffers[_idx];
  __u8* src = cam_data->sib.vmalloc_buffers[_idx];
  unsigned int count = cam_data->sib.vmalloc_vbuffers_size[_idx];
  int fragment_size = cam_data->sib.vmalloc_buffers_size;
  int row, rows = 0;
  unsigned int retval = 0;
  int inc;
  __u8* lptr;
  int leftover = 0;
  int wratio = 1;
  int hratio = 1;
  int evenh = 0;
  int switchh = 1;
  int offset;
  char * dataU;
  char * dataV;
  int bytes_read=0;
  int transfer=0; 
  int size; 
  int idx=0;  
  int bytesperline = cam_data->pix_format.bytesperline;
  const __u8 * crt_gamma = sentech_gamma[cam_data->gamma];
;;
  if ((src == NULL) || (data == NULL) || (count == 0) || (fragment_size == 0)) {;
    return -EINVAL;
  }
  if (cam_data->pix_format.sizeimage < cam_data->sib.vmalloc_vbuffers_size[idx])
    count = cam_data->pix_format.sizeimage;
  if (cam_data->pix_format.sizeimage > count) {
    return -EINVAL;
  }
  if (! param_old_scale) {
    switch(cam_data->fmt->fourcc){
    case V4L2_PIX_FMT_GREY:
    case V4L2_PIX_FMT_SRGGB8:
    case V4L2_PIX_FMT_SGRBG8:
      break;
    default:
      printk(KERN_ALERT "standard scaling not supported without SENTECH_AWB \n");
      return -EINVAL;
    }
    wratio = cam_data->output.left; 
    hratio = cam_data->output.top;  
  } else {
    if (scale) {
      if (cam_data->crop.width)
	wratio = cam_data->scan_width / cam_data->crop.width;
      if (cam_data->crop.height)
	hratio = cam_data->scan_height / cam_data->crop.height;
      if (hratio < 1) hratio = 1;
      switchh = (hratio & 1);;
    }
  }
  switch (cam_data->fmt->fourcc) {
  case V4L2_PIX_FMT_Y16:;
    inc = cam_data->crop.width << 1;
    row = cam_data->crop.top;
    lptr = src + row*cam_data->scan_width;
    for (rows=0;rows<cam_data->crop.height;rows++, row++) {
      gen_line_y16_vmalloc_indir(cam_data, 
		    lptr, data, 
		    cam_data->scan_width, cam_data->crop.width,
		    cam_data->crop.left, row, crt_gamma,
		    cam_data->scan_height);
      data += inc;
      retval += inc;
      lptr += cam_data->scan_width;
    }
    break;    
  case V4L2_PIX_FMT_GREY:
  case V4L2_PIX_FMT_SRGGB8:
  case V4L2_PIX_FMT_SGRBG8:;
    if (cam_data->hflip) {;
      row = (scale?0:cam_data->crop.top);
      lptr = src + row*cam_data->scan_width;    
      inc = cam_data->crop.width;
      wratio = -wratio;
      lptr += cam_data->scan_width-1;
      for (rows=0;rows<cam_data->crop.height;rows++, row+=hratio) {
	int crop_left = scale?0:cam_data->crop.left;
	if (cam_data->hflip) crop_left = -crop_left;
	gen_line_grey_sentech_indir(cam_data, 
			      lptr, data, 
			      cam_data->scan_width, cam_data->crop.width,
			      crop_left, row, crt_gamma,
			      cam_data->scan_height, wratio);
	data += inc;
	retval += inc;
	lptr += cam_data->scan_width*hratio;
      }
      break;
    }
    if (param_bytesperline || 
	(cam_data->scan_width == cam_data->crop.width)) {
      offset = cam_data->crop.top * cam_data->scan_width + cam_data->crop.left;
      size = cam_data->crop.height * cam_data->scan_width;
      {;
	if (size <= 0) return retval;
	transfer = cam_data->sib.vmalloc_buffers_size - offset;
	if (size < transfer) transfer = size;
;
	memcpy(data, src+offset, transfer);
	bytes_read += cam_data->sib.vmalloc_buffers_size;
	data += cam_data->sib.vmalloc_buffers_size;
	retval = bytes_read;;
	size -= cam_data->sib.vmalloc_buffers_size - offset;
	offset = 0;
      }
      return retval;
    }
    row = cam_data->crop.top;
    transfer=cam_data->crop.left;
    transfer += row * cam_data->scan_width;
    {
      __u8* _data;
;
      if(leftover) {row--; rows--;}
      if(rows >= cam_data->crop.height) break;
      for(; rows<cam_data->crop.height;
	  row++, rows++) {
	if(transfer >= fragment_size){;
	  transfer -= fragment_size;
	  break;
	}
	idx = transfer;
	if(leftover > 0) {
	  idx = 0;
	  size = leftover;
	  leftover = 0;
	}else{
	  if (fragment_size-transfer < cam_data->crop.width) {
	    size = fragment_size-transfer;
	    leftover = cam_data->crop.width - size;
	    transfer += cam_data->scan_width;;
	  } else {
	    size = cam_data->crop.width;
	    transfer += cam_data->scan_width;
	  }
	}
	if(count < bytes_read+size) {;
	  retval = -EFAULT;
	  break;
	}
	{
	  _data = data;;
	  memcpy(data, src + idx, size);
	}
	bytes_read += size;
	data += size;
	retval = bytes_read;;
      };
      if (retval == -EFAULT){;
	break;
      }
    }
    break;
  case V4L2_PIX_FMT_SBGGR8:;
    if (param_bytesperline) {
      offset = (cam_data->crop.top+1) * cam_data->scan_width + cam_data->crop.left + 1;
      size = cam_data->crop.height * cam_data->scan_width;
      {
	if (offset >= fragment_size ) {
	  return retval;
	}
	if (size <= 0) return retval;
	transfer = fragment_size-offset;
	if (size < transfer) transfer = size;
;
	memcpy(data, src+offset, transfer);
	bytes_read += fragment_size;
	data += fragment_size;
	retval = bytes_read;
	size -= fragment_size - offset;
	offset = 0;
      }
      return retval;
    }
    row = cam_data->crop.top+1;
    transfer=cam_data->crop.left+1;
    transfer += row * cam_data->scan_width;
    {;
      for(; rows<cam_data->crop.height;
	  row++, rows++) {
	if(transfer >= fragment_size){
	  transfer -= fragment_size;
	  break;
	}
	idx = transfer;
	if (fragment_size-transfer < cam_data->crop.width) {
	  size = fragment_size-transfer;
	} else {
	  size = cam_data->crop.width;
	  transfer += cam_data->scan_width;
	}
	if(count < bytes_read+size) {;
	  retval = -EFAULT;
	  break;
	};
	memcpy(data, 
	       src+idx, 
	       size);
	bytes_read += size;
	data += size;
	retval = bytes_read;
      }
      if (retval == -EFAULT) break;
    }
    break;
  case V4L2_PIX_FMT_BGR24:;
    inc = cam_data->crop.width;
    inc += (inc <<1);
    row = (scale?0:cam_data->crop.top);
    lptr = src + 
      row*cam_data->scan_width;
    evenh = (scale)?(!gbrg):(!(cam_data->crop.top&1));
    for (rows=0;rows<cam_data->crop.height;rows++, row+=hratio) {
      if(lptr - src >= cam_data->scanimage_size) {;
	memset(data, 0, count - retval);
	retval = count;
	break;
      };
      gen_line_bgr24_vmalloc_indir(cam_data, 
		     lptr, data, 
		     cam_data->scan_width, cam_data->crop.width,
		     (scale?0:cam_data->crop.left), row, crt_gamma,
				 cam_data->scan_height, rows, wratio, row, evenh);
      data += inc;
      retval += inc;
      lptr += cam_data->scan_width*hratio;
      evenh ^= switchh;
    }
    if(count > retval);
    memset(data, 0, count - retval);
    retval = count;
    break;
  case V4L2_PIX_FMT_RGB24:;
    inc = cam_data->crop.width;
    inc += (inc <<1);
    row = (scale?0:cam_data->crop.top);
    lptr = src + 
      row*cam_data->scan_width;
    evenh = (scale)?(!gbrg):(!(cam_data->crop.top&1));
    for (rows=0;rows<cam_data->crop.height;rows++, row+=hratio) {
      if(lptr - src >= cam_data->scanimage_size) {;
	memset(data, 0, count - retval);
	retval = count;
	break;
      };
      gen_line_rgb24_vmalloc_indir(cam_data, 
		     lptr, data, 
		     cam_data->scan_width, cam_data->crop.width,
		     (scale?0:cam_data->crop.left), row, crt_gamma,
				 cam_data->scan_height, rows, wratio, row, evenh);
      data += inc;
      retval += inc;
      lptr += cam_data->scan_width*hratio;
      evenh ^= switchh;
    }
    if(count > retval);
    memset(data, 0, count - retval);
    retval = count;
    break;
  case V4L2_PIX_FMT_YUYV:;
    inc = cam_data->crop.width << 1;
    row = (scale?0:cam_data->crop.top);
    lptr = src + 
      row*cam_data->scan_width;
;
    for (rows=0;rows<cam_data->crop.height;rows++, row+=hratio) {
      if (lptr - src >= cam_data->scanimage_size) {;
	memset(data, 0, count - retval);
	retval = count;
	break;
      }
;
      gen_line_yuyv_vmalloc_indir(cam_data, 
			    lptr, data, 
			    cam_data->scan_width, cam_data->crop.width,
			    (scale?0:cam_data->crop.left), row, crt_gamma,
			    cam_data->scan_height,rows,wratio);
      data += inc;
      retval += inc;
      lptr += cam_data->scan_width*hratio;;
    };
    memset(data, 0, count - retval);
    retval = count;
    break;    
  case V4L2_PIX_FMT_YUV420:;
    inc = cam_data->crop.width;
    row = (scale?0:cam_data->crop.top);
    lptr = src + 
      row*cam_data->scan_width;;
    dataU = data+cam_data->crop.width*cam_data->crop.height;
    dataV = dataU + ((cam_data->crop.width*cam_data->crop.height)>>2);;
    for (rows = 0; rows < cam_data->crop.height; rows ++, row += hratio) {;
      gen_line_yuv420_vmalloc_indir(cam_data, 
		   lptr, data, 
		   cam_data->scan_width, cam_data->crop.width,
		   (scale?0:cam_data->crop.left), row, crt_gamma,
		   dataU, dataV, cam_data->scan_height,
			      rows,wratio);
      data += inc;
      if(rows&1) {
	dataU += inc>>1;
	dataV += inc>>1;
	retval += inc;
      }
      retval += inc;
      lptr += cam_data->scan_width*hratio;
    };
    break;    
  case V4L2_PIX_FMT_YUV422P:;
    inc = cam_data->crop.width;
    row = (scale?0:cam_data->crop.top);
    lptr = src + 
      row*cam_data->scan_width;
    dataU = data+cam_data->crop.height*bytesperline;
    dataV = dataU + ((cam_data->crop.width*bytesperline)>>1);
    for (rows=0;rows<cam_data->crop.height;rows++, row+=hratio) {
      gen_line_yuv422P_vmalloc_indir(cam_data, 
		   lptr, data, 
		   cam_data->scan_width, cam_data->crop.width,
		   (scale?0:cam_data->crop.left), row, crt_gamma,
		   dataU, dataV, cam_data->scan_height,
			      rows,wratio);
      data += inc;
      dataU += inc>>1;
      dataV += inc>>1;
      retval += inc;
      retval += inc;
      lptr += cam_data->scan_width*hratio;
    }
    break;    
  default:
    retval=0;
  };
  return retval;
}
#endif
