__s32 _m16829[256];
__s32 _m33039[256];
__s32 _m6416[256];
__s32 _m28784[256];
__s32 _m24103[256];
__s32 _m4681[256];
__s32 _m9714[256];
__s32 _m19070[256];
__s32 _m28784[256];
#define TO_Y(R,G,B) \
  ((9798*R+19234*G+3736*B)>>15)
#define TO_V(R,G,B) \
  (((21208*R-16941*G-3277*B)>>15)+128)
#define TO_U(R,G,B) \
  (((-4784*R -9437*G+4221*B)>>15)+128)
#define mfill(a)				\
  {						\
    __s32 k; 					\
    __s32 a32 = a; 				\
    for(k=0; k<256; k++)			\
      _m##a[k] = a32*k;		                \
  }
void fillm(void){
  mfill(16829);
  mfill(33039);
  mfill(6416);
  mfill(28784);
  mfill(24103);
  mfill(4681);
  mfill(9714);
  mfill(19070);
  mfill(28784);
}
#undef TO_Y
#undef TO_U
#undef TO_V
#define TO_Y(r,g,b) (((_m16829[r] +_m33039[g] +_m6416[b]  + 32768)>>16)+16)
#define TO_V(r,g,b) (((_m28784[r] -_m24103[g] -_m4681[b]  + 32768)>>16)+128)
#define TO_U(r,g,b) (((-_m9714[r] -_m19070[g] +_m28784[b] + 32768)>>16)+128)
inline int norm_rgb(int color, int coef){
  return max(min((color*coef)>>COLOR_SHIFT,255),0);
}
inline int norm_rgb_bright(int color, int brightness){
  return max(min(color+brightness,255),0);
}
#ifndef EXPENSIVE_SAT
static __u8 KOEFF[NB_SATURATIONS];
static __sat_t _m_coef_R_R[NB_SATURATIONS][256];
static __sat_t _m_coef_R_G[NB_SATURATIONS][256];
static __sat_t _m_coef_R_B[NB_SATURATIONS][256];
static __sat_t _m_coef_G_R[NB_SATURATIONS][256];
static __sat_t _m_coef_G_G[NB_SATURATIONS][256];
static __sat_t _m_coef_B_B[NB_SATURATIONS][256];
inline __sat_t _coef_R_R(__u8 R, __u8 K){ return ((292l+(685l*K)/SAT_MED)*R)>>SAT_SHIFT;}
inline __sat_t _coef_R_G(__u8 G, __u8 K){ return ((573l*(SAT_MED-K)*G)/SAT_MED)>>SAT_SHIFT;}
inline __sat_t _coef_R_B(__u8 B, __u8 K){ return ((111l*(SAT_MED-K)*B)/SAT_MED)>>SAT_SHIFT;}
inline __sat_t _coef_G_R(__u8 R, __u8 K){ return (292l*(SAT_MED-K)*R/SAT_MED)>>SAT_SHIFT;}
inline __sat_t _coef_G_G(__u8 G, __u8 K){ return ((573l+403l*K/SAT_MED)*G)>>SAT_SHIFT;}
inline __sat_t _coef_G_B(__u8 B, __u8 K){ return (111l*(SAT_MED-K)*B/SAT_MED)>>SAT_SHIFT;}
inline __sat_t _coef_B_R(__u8 R, __u8 K){ return (292l*(SAT_MED-K)*R/SAT_MED)>>SAT_SHIFT;}
inline __sat_t _coef_B_G(__u8 G, __u8 K){ return ((573l*(SAT_MED-K))*G/SAT_MED)>>SAT_SHIFT;}
inline __sat_t _coef_B_B(__u8 B, __u8 K){ return ((111l+865l*K/SAT_MED)*B)>>SAT_SHIFT;}
void initSaturation(void) {
  int k, col;
;
  for (k = 0; k < NB_SATURATIONS; k ++) {
    KOEFF[k] = k*(256/NB_SATURATIONS); 
    for (col = 0; col < 256; col ++) {
      mb();
      _m_coef_R_R[k][col] = _coef_R_R(col, KOEFF[k]);
      _m_coef_R_G[k][col] = _coef_R_G(col, KOEFF[k]);
      _m_coef_R_B[k][col] = _coef_R_B(col, KOEFF[k]);
      _m_coef_G_R[k][col] = _coef_G_R(col, KOEFF[k]);
      _m_coef_G_G[k][col] = _coef_G_G(col, KOEFF[k]);
      _m_coef_B_B[k][col] = _coef_B_B(col, KOEFF[k]);
    }
  };
}
inline void setSaturations(__u8 K) {
  _KRR=_m_coef_R_R[K];
  _KRG=_m_coef_R_G[K];
  _KRB=_m_coef_R_B[K];
  _KGR=_m_coef_G_R[K];
  _KGG=_m_coef_G_G[K];
  _KBB=_m_coef_B_B[K];
}
inline __sat_t coef_R_Ro(__u8 R, __sat_t* K){ return K[R];}
inline __sat_t coef_R_Go(__u8 G, __sat_t* K){ return K[G];}
inline __sat_t coef_R_Bo(__u8 B, __sat_t* K){ return K[B];}
inline __sat_t coef_G_Ro(__u8 R, __sat_t* K){ return K[R];}
inline __sat_t coef_G_Go(__u8 G, __sat_t* K){ return K[G];}
inline __sat_t coef_B_Bo(__u8 B, __sat_t* K){ return K[B];}
inline __u8 SaturateRo(__u8 R, __u8 G, __u8 B, __sat_t* KRR, __sat_t* KRG, __sat_t* KRB){
  int result =  (coef_R_Ro(R,KRR)+coef_R_Go(G,KRG)+coef_R_Bo(B,KRB))>>(10-SAT_SHIFT);
  return (__u8)min(255,max(0,result));
}
inline __u8 SaturateGo(__u8 R, __u8 G, __u8 B, __sat_t* KGR, __sat_t* KGG, __sat_t* KRB){
  int result =  (coef_G_Ro(R,KGR)+coef_G_Go(G,KGG)+coef_R_Bo(B,KRB))>>(10-SAT_SHIFT);
  return (__u8)min(255,max(0,result));
}
inline __u8 SaturateBo(__u8 R, __u8 G, __u8 B, __sat_t* KGR, __sat_t* KRG, __sat_t* KBB){
  int result =  (coef_G_Ro(R,KGR)+coef_R_Go(G,KRG)+coef_B_Bo(B,KBB))>>(10-SAT_SHIFT);
  return (__u8)min(255,max(0,result));
}
#else
inline void setSaturations(__u8 K){}
void initSaturation(void){}
inline __sat_t coef_R_R(__u8 R, __u8 K){ return ((292l+(685l*K)/SAT_MED)*R)>>SAT_SHIFT;}
inline __sat_t coef_R_G(__u8 G, __u8 K){ return ((573l*(SAT_MED-K)*G)/SAT_MED)>>SAT_SHIFT;}
inline __sat_t coef_R_B(__u8 B, __u8 K){ return ((111l*(SAT_MED-K)*B)/SAT_MED)>>SAT_SHIFT;}
inline __sat_t coef_G_R(__u8 R, __u8 K){ return (292l*(SAT_MED-K)*R/SAT_MED)>>SAT_SHIFT;}
inline __sat_t coef_G_G(__u8 G, __u8 K){ return ((573l+403l*K/SAT_MED)*G)>>SAT_SHIFT;}
inline __sat_t coef_G_B(__u8 B, __u8 K){ return (111l*(SAT_MED-K)*B/SAT_MED)>>SAT_SHIFT;}
inline __sat_t coef_B_R(__u8 R, __u8 K){ return (292l*(SAT_MED-K)*R/SAT_MED)>>SAT_SHIFT;}
inline __sat_t coef_B_G(__u8 G, __u8 K){ return ((573l*(SAT_MED-K))*G/SAT_MED)>>SAT_SHIFT;}
inline __sat_t coef_B_B(__u8 B, __u8 K){ return ((111l+865l*K/SAT_MED)*B)>>SAT_SHIFT;}
inline __u8 SaturateR(__u8 R, __u8 G, __u8 B, __u8 K){
  int result =  (coef_R_R(R,K)+coef_R_G(G,K)+coef_R_B(B,K))>>(10-SAT_SHIFT);
  return (__u8)min(255,max(0,result));
}
inline __u8 SaturateG(__u8 R, __u8 G, __u8 B, __u8 K){
  int result =  (coef_G_R(R,K)+coef_G_G(G,K)+coef_G_B(B,K))>>(10-SAT_SHIFT);
  return (__u8)min(255,max(0,result));
}
inline __u8 SaturateB(__u8 R, __u8 G, __u8 B, __u8 K){
  int result =  (coef_B_R(R,K)+coef_B_G(G,K)+coef_B_B(B,K))>>(10-SAT_SHIFT);
  return (__u8)min(255,max(0,result));
} 
#endif
inline void interpolateRGBg(__u8*R, __u8*G, __u8*B,
			    __u8* image, int _brightness,
			    int line_prev, int pix_prev,
			    int line_next, int pix_next,
			    int src_ptr, int line_start, int w,
			    int red, int green, int blue,
			    int evenh, int evenw,
			    const __u8 * crt_gamma,
			    struct sentech_camera* cam_data) {
  int saturation = cam_data->saturation;;
  if(!color_correction){
    if(evenh)
      if(evenw){ 
	*R = crt_gamma[image[src_ptr]];
	*G = crt_gamma[(((__u16)0)+image[line_prev+w]+image[line_next+w]+
			image[line_start+pix_prev]+
			image[line_start+pix_next])>>2];
	*B = crt_gamma[(((__u16)0)+image[line_prev+pix_prev]+
			image[line_prev+pix_next]+
			image[line_next+pix_prev]+
			image[line_next+pix_next])>>2];
      }else{     
	*R = crt_gamma[(((__u16)0)+image[line_start+pix_prev]+image[line_start+pix_next])>>1];
	*G = crt_gamma[image[src_ptr]];
	*B = crt_gamma[(((__u16)0)+image[line_prev+w]+image[line_next+w])>>1];
      }
    else
      if(evenw){ 
	*B = crt_gamma[(((__u16)0)+image[line_start+pix_prev]+image[line_start+pix_next])>>1];
	*G = crt_gamma[image[src_ptr]];
	*R = crt_gamma[(((__u16)0)+image[line_prev+w]+image[line_next+w])>>1];
      }else{     
	*R = crt_gamma[(((__u16)0)+image[line_prev+pix_prev]+image[line_prev+pix_next]+
			image[line_next+pix_prev]+image[line_next+pix_next])>>2];
	*G = crt_gamma[(((__u16)0)+image[line_prev+w]+image[line_next+w]+
			image[line_start+pix_prev]+image[line_start+pix_next])>>2];
	*B = crt_gamma[image[src_ptr]];
      }
  }else{
    if(evenh)
      if(evenw){ 
	*R = crt_gamma[norm_rgb(image[src_ptr], red)];
	*B = crt_gamma[norm_rgb((0l+image[line_prev+pix_prev]+image[line_prev+pix_next]+
				 image[line_next+pix_prev]+image[line_next+pix_next])>>2, 
				blue)];
	*G = crt_gamma[norm_rgb((0l+image[line_prev+w]+image[line_next+w]+
				 image[line_start+pix_prev]+image[line_start+pix_next])>>2, 
				green)];
      }else{     
	*G = crt_gamma[norm_rgb(image[src_ptr],green)];
	*R = crt_gamma[norm_rgb((0l+image[line_start+pix_prev]+image[line_start+pix_next])>>1,
				red)];
	*B = crt_gamma[norm_rgb((0l+image[line_prev+w]+image[line_next+w])>>1,
				blue)];
      }
    else
      if(evenw){ 
	*G = crt_gamma[norm_rgb(image[src_ptr],green)];
	*B = crt_gamma[norm_rgb((0l+image[line_start+pix_prev]+image[line_start+pix_next])>>1,
				blue)];
	*R = crt_gamma[norm_rgb((0l+image[line_prev+w]+image[line_next+w])>>1,
				red)];
      }else{     
	*B = crt_gamma[norm_rgb(image[src_ptr],blue)];
	*R = crt_gamma[norm_rgb((0l+image[line_prev+pix_prev]+image[line_prev+pix_next]+
				 image[line_next+pix_prev]+image[line_next+pix_next])>>2,
				red)];
	*G = crt_gamma[norm_rgb((0l+image[line_prev+w]+image[line_next+w]+
				 image[line_start+pix_prev]+image[line_start+pix_next])>>2,
				green)];  
    }
  }
;
  if(cfg_saturation||(saturation != SATDEF)){
    __u8 Rs,Gs,Bs;
#ifdef EXPENSIVE_SAT
    Rs = SaturateR(*R,*G,*B,saturation);
    Gs = SaturateG(*R,*G,*B,saturation);
    Bs = SaturateB(*R,*G,*B,saturation);
#else
    Rs = SaturateRo(*R,*G,*B, _KRR, _KRG, _KRB);
    Gs = SaturateGo(*R,*G,*B, _KGR, _KGG, _KRB);
    Bs = SaturateBo(*R,*G,*B, _KGR, _KRG, _KBB);
#endif
    *R=Rs;
    *G=Gs;
    *B=Bs;
  };
  if(brightness_correction){
    *R = norm_rgb_bright(*R,_brightness);
    *G = norm_rgb_bright(*G,_brightness);
    *B = norm_rgb_bright(*B,_brightness);
  };
}
inline void interpolateRGB(__u8*R, __u8*G, __u8*B,
			   __u8* image, int _brightness,
			   int line_prev, int pix_prev,
			   int line_next, int pix_next,
			   int src_ptr, int line_start, int w,
			   int red, int green, int blue,
			   int evenh, int evenw,
			   struct sentech_camera* cam_data) {
  __u8 Rs,Gs,Bs;
  const __u8 *crt_gamma = sentech_gamma[cam_data->gamma];
  if(evenh)
    if(evenw){ 
      *R = norm_rgb(image[src_ptr], red);
      *B = norm_rgb((0l+image[line_prev+pix_prev]+image[line_prev+pix_next]+
		    image[line_next+pix_prev]+image[line_next+pix_next])>>2, blue);
      *G = norm_rgb((0l+image[line_prev+w]+image[line_next+w]+
		    image[line_start+pix_prev]+image[line_start+pix_next])>>2, green);
    }else{     
      *G = norm_rgb(image[src_ptr],green);
      *R = norm_rgb((0l+image[line_start+pix_prev]+image[line_start+pix_next])>>1, red);
      *B = norm_rgb((0l+image[line_prev+w]+image[line_next+w])>>1, blue);
    }
  else
    if(evenw){ 
      *G = norm_rgb(image[src_ptr],green);
      *B = norm_rgb((0l+image[line_start+pix_prev]+image[line_start+pix_next])>>1, blue);
      *R = norm_rgb((0l+image[line_prev+w]+image[line_next+w])>>1, red);
    }else{     
      *B = norm_rgb(image[src_ptr],blue);
      *R = norm_rgb((0l+image[line_prev+pix_prev]+image[line_prev+pix_next]+
		    image[line_next+pix_prev]+image[line_next+pix_next])>>2, red);
      *G = norm_rgb((0l+image[line_prev+w]+image[line_next+w]+
		    image[line_start+pix_prev]+image[line_start+pix_next])>>2, green);  
    }
#ifdef EXPENSIVE_SAT
  {
  int saturation = cam_data->saturation;
  Rs = norm_rgb_bright(SaturateR(crt_gamma[(*R)],crt_gamma[(*G)],crt_gamma[(*B)],saturation),_brightness);
  Gs = norm_rgb_bright(SaturateG(crt_gamma[(*R)],crt_gamma[(*G)],crt_gamma[(*B)],saturation),_brightness);
  Bs = norm_rgb_bright(SaturateB(crt_gamma[(*R)],crt_gamma[(*G)],crt_gamma[(*B)],saturation),_brightness);
  }
#else
  Rs = SaturateRo(crt_gamma[(*R)],crt_gamma[(*G)],crt_gamma[(*B)], _KRR, _KRG, _KRB);
  Gs = SaturateGo(crt_gamma[(*R)],crt_gamma[(*G)],crt_gamma[(*B)], _KGR, _KGG, _KRB);
  Bs = SaturateBo(crt_gamma[(*R)],crt_gamma[(*G)],crt_gamma[(*B)], _KGR, _KRG, _KBB);
#endif
  *R=Rs;
  *G=Gs;
  *B=Bs;
  if(brightness_correction){
    *R = norm_rgb_bright(*R,_brightness);
    *G = norm_rgb_bright(*G,_brightness);
    *B = norm_rgb_bright(*B,_brightness);
  }
}
__attribute__((always_inline)) inline void
gen_line_bgr24(struct sentech_camera *cam_data,
	       __u8* frame , char __user *data,
	       int max_width , int wmax ,
	       int wstart , int h ,
	       const __u8 * crt_gamma) {
  int  evenh, evenw;
  int brightness = cam_data->brightness;
  int red = cam_data->red, green = cam_data->green, blue = cam_data->blue;
  int w, wmax_abs;
  int line_start = 0, line_prev = -max_width, line_next = max_width;
  __u8 R; 
  __u16 BG;
  char __user *p=data;
  int src_ptr;
  int pix_prev, pix_next;
  if(unlikely(!h)) line_prev = line_next;
  if(unlikely(h == cam_data->scan_height)) line_next = line_prev;
  evenh = !(h & 1);
  wmax_abs = wmax+wstart-1;
  for (w=wstart+1;w<wmax_abs;w++) {
    src_ptr = line_start+w;
    pix_prev = w-1, pix_next = w+1;
    evenw = !(w & 1);
    interpolateRGBg(
		   &R, ((__u8*)&BG)+1, (__u8*)&BG,
		   frame, brightness,
		   line_prev, pix_prev,
		   line_next, pix_next,
		   src_ptr, line_start, w,
		   red, green, blue,
		   evenh, evenw, crt_gamma, cam_data);
    __put_user(BG,(__u16*)p);
    p++;
    p++;
    __put_user(R,p);
    p++;
  }
}
__attribute__((always_inline)) inline void
gen_line_rgb24(struct sentech_camera *cam_data,
	       __u8* frame , char __user *data,
	       int max_width , int wmax ,
	       int wstart , int h ,
		const __u8 * crt_gamma
	       ) {
  int  evenh, evenw;
  int brightness = cam_data->brightness;
  int red = cam_data->red, green = cam_data->green, blue = cam_data->blue;
  int w, wmax_abs;
  int line_start = 0, line_prev = -max_width, line_next = max_width;
  __u8  B;
  __u16 RG;
  char __user *p=data;
  int src_ptr;
  int pix_prev, pix_next;
  if(unlikely(!h)) line_prev = line_next;
  if(unlikely(h == (cam_data->scan_height-1))) line_next = line_prev;
  evenh = !(h & 1);
  wmax_abs = wmax+wstart-1;
  for (w=wstart+1;w<wmax_abs;w++) {
    src_ptr = line_start+w;
    pix_prev = w-1, pix_next = w+1;
    evenw = !(w & 1);
    interpolateRGBg(
		   (__u8*)&RG, ((__u8*)&RG)+1, &B,
		   frame, brightness,
		   line_prev, pix_prev,
		   line_next, pix_next,
		   src_ptr, line_start, w,
		   red, green, blue,
		   evenh, evenw, crt_gamma, cam_data);
    __put_user(RG,(__u16*)p);
    p++;
    p++;
    __put_user(B,p);
    p++;
  }
}
__attribute__((always_inline)) inline void
gen_line_yuv420(struct sentech_camera *cam_data,
		__u8* frame , char __user *data,
		int max_width , int wmax ,
		int wstart , int h ,
		const __u8 * crt_gamma,
		char __user *dataU,
		char __user *dataV, int max_height, int rows, int hratio) {
  int  evenh, evenw, even_rows, even_w_idx;
  int brightness = cam_data->brightness;
  int red = cam_data->red, green = cam_data->green, blue = cam_data->blue;
  int w, wmax_abs;
  int line_start = 0, line_prev = -max_width, line_next = max_width;
  __u8 R, G, B;
  __u8 Y, U, V;
  int src_ptr;
  int pix_prev, pix_next;
  int w_idx=0, wmax1 = wstart+wmax-1;
  if(unlikely(!h)) line_prev = line_next;
  else if(unlikely(h==max_height-1)) line_next = line_prev;
  evenh = !(h & 1);
  even_rows = !(rows & 1);
  wmax_abs = wmax+wstart;
  for (w_idx=0,w=wstart; w_idx<wmax; w_idx++,w+=hratio) {
    src_ptr = line_start+w;
    pix_prev = w-1; pix_next = w+1;
    if(!w) {pix_prev = pix_next;}
    else if(w == wmax1) {pix_next=pix_prev;}
    evenw = !(w & 1);
    interpolateRGBg(&R, &G, &B,
		    frame, brightness,
		    line_prev, pix_prev,
		    line_next, pix_next,
		    src_ptr, line_start, w,
		    red, green, blue,
		   evenh, evenw, crt_gamma, cam_data);    
    Y = TO_Y(R,G,B);
    __put_user(Y,data);
    data++;
    even_w_idx = !(w_idx & 1);
    if(even_rows && even_w_idx){
      U=TO_U(R,G,B);
      __put_user(U,dataU);
      dataU++;
      V=TO_V(R,G,B);
      __put_user(V,dataV);
      dataV++;
    }
  }
}
__attribute__((always_inline)) inline void
gen_line_yuv422P(struct sentech_camera *cam_data,
		__u8* frame , char __user *data,
		int max_width , int wmax ,
		int wstart , int h ,
		const __u8 * crt_gamma,
		char __user *dataU,
		 char __user *dataV, int max_height, int hratio) {
  int  evenh, evenw, even_w_idx;
  int brightness = cam_data->brightness;
  int red = cam_data->red, green = cam_data->green, blue = cam_data->blue;
  int w, wmax_abs;
  int line_start = 0, line_prev = -max_width, line_next = max_width;
  __u8 R, G, B;
  __u8 Y, U, V;
  int src_ptr;
  int pix_prev, pix_next;
  int w_idx=0, wmax1 = wstart+wmax-1;
  if(unlikely(!h)) line_prev = line_next;
  else if(unlikely(h==max_height-1)) line_next = line_prev;
  evenh = !(h & 1);
  wmax_abs = wmax+wstart;
  for (w_idx=0,w=wstart; w_idx<wmax; w_idx++,w+=hratio) {
    src_ptr = line_start+w;
    pix_prev = w-1; pix_next = w+1;
    if(!w) {pix_prev = pix_next;}
    else if(w == wmax1) {pix_next=pix_prev;}
    evenw = !(w & 1);
    interpolateRGBg(&R, &G, &B,
		    frame, brightness,
		    line_prev, pix_prev,
		    line_next, pix_next,
		    src_ptr, line_start, w,
		    red, green, blue,
		   evenh, evenw, crt_gamma, cam_data);    
    Y = TO_Y(R,G,B);
    __put_user(Y,data);
    data++;
    even_w_idx = !(w_idx & 1);
    if(even_w_idx){
      U=TO_U(R,G,B);
      __put_user(U,dataU);
      dataU++;
      V=TO_V(R,G,B);
      __put_user(V,dataV);
      dataV++;
    }
  }
}
__attribute__((always_inline)) inline void
gen_line_yuyv(struct sentech_camera *cam_data,
	      __u8* frame , char __user *data,
	      int max_width , int wmax ,
	      int wstart , int h ,
	      const __u8 * crt_gamma,
	      int max_height) {
  int  evenh, evenw;
  int brightness = cam_data->brightness;
  int red = cam_data->red, green = cam_data->green, blue = cam_data->blue;
  int w, wmax_abs;
  int line_start = 0, line_prev = -max_width, line_next = max_width;
  __u8 R, G, B;
  __u8 Y, U, V;
  char __user *p=data;
  int src_ptr;
  int pix_prev, pix_next;
  int wmax1 = wstart+wmax-1;
  if(unlikely(!h)) line_prev = line_next;
  else if(unlikely(h==(max_height-1))) line_next = line_prev;
  evenh = !(h & 1);
  wmax_abs = wmax+wstart;
  for (w=wstart;w<wmax_abs;w++) {
    src_ptr = line_start+w;
    pix_prev = w-1; pix_next = w+1;
    if(!w) {pix_prev = pix_next;}
    else if(w == wmax1) {pix_next=pix_prev;}
    evenw = !(w & 1);
    interpolateRGBg(&R, &G, &B,
		    frame, brightness,
		    line_prev, pix_prev,
		    line_next, pix_next,
		    src_ptr, line_start, w,
		    red, green, blue,
		   evenh, evenw, crt_gamma, cam_data);    
    Y = TO_Y(R,G,B);
    __put_user(Y,p);
    p++;
    if(evenw){
      U=TO_U(R,G,B);
      __put_user(U,p);
    }else{
      V=TO_V(R,G,B);
      __put_user(V,p);
    }
    p++;
  }
}
static int 
move_sub_to_user(struct sentech_usb_buffer* sub,
		 char __user *data,
		 size_t count) {
  struct sentech_camera* cam_data = sub->cam_data;
  struct sentech_usb_fragment* suf;
  int row, rows=0;
  unsigned int transfer=0; 
  unsigned int size; 
  int idx=0;  
  int i, retval = 0;
  int bytes_read=0;
  int inc;  
  int pix_w_dest;  
  int hratio=1;
  int rows_output;
  unsigned int offset;
  int real_fragment_size;
  __u8* lptr;
  char __user * dataU;
  char __user * dataV;
  const __u8 * crt_gamma = sentech_gamma[cam_data->gamma];
  if(!access_ok(VERIFY_WRITE, (void __user*)data, count)){;
    return -EFAULT;
  }
  if((cam_data->pix_format.sizeimage > count)&&
     (count % cam_data->pix_format.bytesperline == 0)) {
    cam_data->pix_format.height=cam_data->crop.height =cam_data->height=cam_data->output.height = count / cam_data->pix_format.bytesperline;
    cam_data->output.top=1;
    cam_data->pix_format.sizeimage = cam_data->pix_format.bytesperline*cam_data->height;
  }
  if(cam_data->pix_format.sizeimage > count) {;
    return -EINVAL;
  }
  pix_w_dest=(param_old_scale)?cam_data->crop.width:cam_data->output.width;
  hratio = (param_old_scale)?1:cam_data->output.top;
  if(hratio<1) hratio=1;
  if(cam_data->output.left!=1) {
    cam_data->output.left=1;
    cam_data->crop.width = cam_data->output.width;;
  }
  switch(cam_data->fmt->fourcc){
  case V4L2_PIX_FMT_GREY:
  case V4L2_PIX_FMT_SRGGB8:
  case V4L2_PIX_FMT_SGRBG8:
    inc=pix_w_dest;
    if(hratio!=1) {
      hratio = 1;
      cam_data->output.top = 1;
      cam_data->crop.height = cam_data->output.height;
    }
    if (param_bytesperline || 
	(cam_data->max_width == ((unsigned)pix_w_dest))) {
      offset = cam_data->crop.top * cam_data->max_width + cam_data->crop.left;
      size = cam_data->crop.height * cam_data->max_width;
      list_for_each_entry(suf, &sub->suf_buffers, buffers) {
	real_fragment_size = suf->fragment_size;
	if(suf->first_suf) real_fragment_size += sizeof(struct Sentech_Header);
	if(offset >= real_fragment_size) {
	  offset -= real_fragment_size;
	  continue;
	}
	if(size<=0) break;
	transfer = real_fragment_size-offset;
	if(size < transfer) transfer = size;
	if (__copy_to_user(data, suf->framebuffer_image+offset,
			   transfer)){;
	  retval = -EFAULT;
	  break;
	}else{
	  bytes_read += transfer; 
	  data += transfer; 
	  retval = bytes_read;
	  size -= transfer; 
	  offset = 0;
	}
      }
      return retval;
    }
    row = cam_data->crop.top;
    transfer=cam_data->crop.left;
    transfer += row * cam_data->max_width;
    list_for_each_entry(suf, &sub->suf_buffers, buffers) {;
      real_fragment_size = suf->fragment_size;
      if(suf->first_suf) real_fragment_size += sizeof(struct Sentech_Header);
      for(; rows<cam_data->crop.height;
	  row++, rows++) {
	if(transfer >= real_fragment_size){
	  transfer -= real_fragment_size;
	  break;
	}
	idx = transfer;
	if (real_fragment_size-transfer < ((unsigned)cam_data->crop.width)) {
	  size = real_fragment_size-transfer;
	} else {
	  size = cam_data->crop.width;
	  transfer += cam_data->max_width;
	}
	if(count < bytes_read+size) {;
	  retval = -EFAULT;
	  break;
	}
	if (copy_to_user(data, 
			 suf->framebuffer_image+idx, 
			 size)){;
	  retval = -EFAULT;
	  break;
	}else{
	  bytes_read += size;
	  data += size;
	  retval = bytes_read;;
	}
      }
      if (retval == -EFAULT) break;
    }
    break;
  case V4L2_PIX_FMT_SBGGR8:;
    if(!param_old_scale){;
      break;
    }
    if (param_bytesperline) {
      offset = (cam_data->crop.top+1) * cam_data->max_width + cam_data->crop.left + 1;
      size = cam_data->crop.height * cam_data->max_width;
      list_for_each_entry(suf, &sub->suf_buffers, buffers) {
	if(offset >= suf->fragment_size) {
	  offset -= suf->fragment_size;
	  continue;
	}
	if(size<=0) break;
	transfer = suf->fragment_size-offset;
	if(size < transfer) transfer = size;
	if (__copy_to_user(data, suf->framebuffer_image+offset,
			   transfer)){;
	  retval = -EFAULT;
	  break;
	}else{
	  bytes_read += suf->fragment_size;
	  data += suf->fragment_size;
	  retval = bytes_read;
	  size -= suf->fragment_size-offset;
	  offset = 0;
	}
      }
      return retval;
    }
    row = cam_data->crop.top+1;
    transfer=cam_data->crop.left+1;
    transfer += row * cam_data->max_width;
    list_for_each_entry(suf, &sub->suf_buffers, buffers) {;
      for(; rows<cam_data->crop.height;
	  row++, rows++) {
	if(transfer >= suf->fragment_size){
	  transfer -= suf->fragment_size;
	  break;
	}
	idx = transfer;
	if (suf->fragment_size-transfer < ((unsigned)cam_data->crop.width)) {
	  size = suf->fragment_size-transfer;
	} else {
	  size = cam_data->crop.width;
	  transfer += cam_data->max_width;
	}
	if(count < bytes_read+size) {;
	  retval = -EFAULT;
	  break;
	}
	if (__copy_to_user(data, 
			 suf->framebuffer_image+idx, 
			 size)){;
	  retval = -EFAULT;
	  break;
	}else{
	  bytes_read += size;
	  data += size;
	  retval = bytes_read;
	}
      }
      if (retval == -EFAULT) break;
    }
    break;
  case V4L2_PIX_FMT_BGR24:;;
    if(param_old_scale)
      inc = cam_data->crop.width;
    else
      inc = cam_data->output.width;
    inc += (inc <<1);
    suf = first_suf(sub);
    row = cam_data->crop.top;
    lptr = suf->framebuffer_image + 
      row*cam_data->max_width;
    hratio = cam_data->output.top;
    if(hratio<1) hratio=1;
    rows_output = (param_old_scale)?
      cam_data->crop.height:
      cam_data->output.height;
    for (rows=0;rows<rows_output;row+=hratio, rows++) {
      if(retval+inc>count) break;
      gen_line_bgr24(cam_data, 
		     lptr, data, 
		     cam_data->max_width, 
		     (param_old_scale?cam_data->crop.width:cam_data->output.width),
		     cam_data->crop.left, row, crt_gamma);
      data += inc;
      retval += inc;
      lptr += cam_data->max_width;
    }
    break;
  case V4L2_PIX_FMT_RGB24:;;
    if(param_old_scale)
      inc = cam_data->crop.width;
    else
      inc = cam_data->output.width;
    inc += (inc <<1);
    suf = first_suf(sub);
    row = cam_data->crop.top;
    lptr = suf->framebuffer_image + 
      row*cam_data->max_width;
    hratio = cam_data->output.top;
    if(hratio<1) hratio=1;
    rows_output = (param_old_scale)?
      cam_data->crop.height:
      cam_data->output.height;
    for (rows=0;rows<rows_output;row+=hratio, rows++) {
      if(retval+inc>count) break;
      gen_line_rgb24(cam_data, 
		     lptr, data, 
		     cam_data->max_width,
		     (param_old_scale?cam_data->crop.width:cam_data->output.width),
		     cam_data->crop.left, row, crt_gamma);
      data += inc;
      retval += inc;
      lptr += cam_data->max_width;
    }
    break;
  case V4L2_PIX_FMT_YUYV:;;
    if(param_old_scale)
      inc = cam_data->crop.width << 1;
    else
      inc = cam_data->output.width << 1;
    suf = first_suf(sub);
    row = cam_data->crop.top;
    lptr = suf->framebuffer_image + 
      row*cam_data->max_width;
    hratio = cam_data->output.top;
    if(hratio<1) hratio=1;
    rows_output = (param_old_scale)?
      cam_data->crop.height:
      cam_data->output.height;
    for (rows=0;rows<rows_output;row+=hratio, rows++) {
      if(retval+inc>count) break;
      gen_line_yuyv(cam_data, 
		    lptr, data, 
		    cam_data->max_width, 
		    (param_old_scale?cam_data->crop.width:cam_data->output.width),
		    cam_data->crop.left, row, crt_gamma,
		    cam_data->max_height);
      data += inc;
      if(0){
	for(i=0; i< cam_data->crop.width; i++, data++) {
	  __put_user(0x80,data);
	  __put_user(0x80,data);
	}
      }
      if(0){
	for(i=0; i< cam_data->crop.width; i++, data++) {
	  __put_user(0,data);
	  __put_user(0,data);
	}
      }
      retval += inc;
      lptr += cam_data->max_width;
    }
    break;    
  case V4L2_PIX_FMT_YUV420:;;
    if(param_old_scale)
      inc = cam_data->crop.width;
    else
      inc = cam_data->output.width;
    suf = first_suf(sub);
    row = cam_data->crop.top;
    lptr = suf->framebuffer_image + 
      row*cam_data->max_width;
    rows_output = (param_old_scale)?
      cam_data->crop.height:
      cam_data->output.height;
    dataU = data+cam_data->crop.width*cam_data->crop.height;
    dataV = dataU + ((cam_data->crop.width*cam_data->crop.height)>>2);
    for (rows=0;rows<rows_output;rows++, row+=hratio) {
      if(retval+inc>count) break;
      gen_line_yuv420(cam_data, 
		      lptr, data, 
		      cam_data->max_width, 
		      (param_old_scale?cam_data->crop.width:cam_data->output.width),
		      cam_data->crop.left, row, crt_gamma,
		      dataU, dataV, cam_data->max_height, rows, hratio);
      data += inc;
      if(rows&1) {
	dataU += inc>>1;
	dataV += inc>>1;
	retval += inc;
      }
      retval += inc;
      lptr += cam_data->max_width;
    }
    break;    
  case V4L2_PIX_FMT_YUV422P:;;
    if(param_old_scale)
      inc = cam_data->crop.width;
    else
      inc = cam_data->output.width;
    suf = first_suf(sub);
    row = cam_data->crop.top;
    lptr = suf->framebuffer_image + 
      row*cam_data->max_width;
    rows_output = (param_old_scale)?
      cam_data->crop.height:
      cam_data->output.height;
    dataU = data+cam_data->crop.width*cam_data->crop.height;
    dataV = dataU + ((cam_data->crop.width*cam_data->crop.height)>>1);
    for (rows=0;rows<rows_output;rows++, row+=hratio) {
      if(retval+inc>count) break;
      gen_line_yuv422P(cam_data, 
		      lptr, data, 
		      cam_data->max_width,
		       (param_old_scale?cam_data->crop.width:cam_data->output.width),
		      cam_data->crop.left, row, crt_gamma,
		       dataU, dataV, cam_data->max_height, hratio);
      data += inc;
	dataU += inc>>1;
	dataV += inc>>1;
	retval += inc;
      retval += inc;
      lptr += cam_data->max_width;
    }
    break;    
  default:;
    retval=0;
  }
  return retval;
}
