#define T_S __u16
#define T_D __u16
#define T_G __u16
#define T_KI __u8
#define T_K __u8
#define _KS 256
#define T_C __u16
#define T_2C __u32
#define _CS 4096
#define MAX_CS (_CS-1)
#define B_CS 4
__s32 _16_m16829[_CS];
__s32 _16_m33039[_CS];
__s32 _16_m6416[_CS];
__s32 _16_m28784[_CS];
__s32 _16_m24103[_CS];
__s32 _16_m4681[_CS];
__s32 _16_m9714[_CS];
__s32 _16_m19070[_CS];
__s32 _16_m28784[_CS];
#define mfill_16(a)				\
  {						\
    __s32 k; 					\
    __s32 a32 = a; 				\
    for(k=0; k<_CS; k++)			\
      _16_m##a[k] = a32*k;		                \
  }
void fillm_16(void){
  mfill_16(16829);
  mfill_16(33039);
  mfill_16(6416);
  mfill_16(28784);
  mfill_16(24103);
  mfill_16(4681);
  mfill_16(9714);
  mfill_16(19070);
  mfill_16(28784);
}
#define TO_Y_16(r,g,b) (((_16_m16829[r] +_16_m33039[g] +_16_m6416[b]  + 32768)>>16)+(16<<B_CS))
#define TO_V_16(r,g,b) (((_16_m28784[r] -_16_m24103[g] -_16_m4681[b]  + 32768)>>16)+(128<<B_CS))
#define TO_U_16(r,g,b) (((-_16_m9714[r] -_16_m19070[g] +_16_m28784[b] + 32768)>>16)+(128<<B_CS))
inline int norm_rgb_16(int color, int coef){
  return max(min((color*coef)>>COLOR_SHIFT,MAX_CS),0);
}
inline int norm_rgb_bright_16(int color, int brightness){
  return max(min(color+brightness,MAX_CS),0);
}
#ifndef EXPENSIVE_SAT
static T_K KOEFF_16[NB_SATURATIONS];
static __sat_t _m_coef_R_R_16[NB_SATURATIONS][_CS];
static __sat_t _m_coef_R_G_16[NB_SATURATIONS][_CS];
static __sat_t _m_coef_R_B_16[NB_SATURATIONS][_CS];
static __sat_t _m_coef_G_R_16[NB_SATURATIONS][_CS];
static __sat_t _m_coef_G_G_16[NB_SATURATIONS][_CS];
static __sat_t _m_coef_B_B_16[NB_SATURATIONS][_CS];
inline __sat_t _coef_R_R_16(T_C R, T_K K){ return ((292l+(685l*K)/SAT_MED)*R)>>SAT_SHIFT;}
inline __sat_t _coef_R_G_16(T_C G, T_K K){ return ((573l*(SAT_MED-K)*G)/SAT_MED)>>SAT_SHIFT;}
inline __sat_t _coef_R_B_16(T_C B, T_K K){ return ((111l*(SAT_MED-K)*B)/SAT_MED)>>SAT_SHIFT;}
inline __sat_t _coef_G_R_16(T_C R, T_K K){ return (292l*(SAT_MED-K)*R/SAT_MED)>>SAT_SHIFT;}
inline __sat_t _coef_G_G_16(T_C G, T_K K){ return ((573l+403l*K/SAT_MED)*G)>>SAT_SHIFT;}
inline __sat_t _coef_G_B_16(T_C B, T_K K){ return (111l*(SAT_MED-K)*B/SAT_MED)>>SAT_SHIFT;}
inline __sat_t _coef_B_R_16(T_C R, T_K K){ return (292l*(SAT_MED-K)*R/SAT_MED)>>SAT_SHIFT;}
inline __sat_t _coef_B_G_16(T_C G, T_K K){ return ((573l*(SAT_MED-K))*G/SAT_MED)>>SAT_SHIFT;}
inline __sat_t _coef_B_B_16(T_C B, T_K K){ return ((111l+865l*K/SAT_MED)*B)>>SAT_SHIFT;}
void initSaturation_16(void) {
  T_KI k;
  T_C col;
  for (k = 0; k < NB_SATURATIONS; k ++) {
    KOEFF_16[k] = k*(_KS/NB_SATURATIONS); 
    for (col = 0; col < _CS; col ++) {
      mb();
      _m_coef_R_R_16[k][col] = _coef_R_R_16(col, KOEFF_16[k]);
       _m_coef_R_G_16[k][col] = _coef_R_G_16(col, KOEFF_16[k]);
       _m_coef_R_B_16[k][col] = _coef_R_B_16(col, KOEFF_16[k]);
       _m_coef_G_R_16[k][col] = _coef_G_R_16(col, KOEFF_16[k]);
       _m_coef_G_G_16[k][col] = _coef_G_G_16(col, KOEFF_16[k]);
       _m_coef_B_B_16[k][col] = _coef_B_B_16(col, KOEFF_16[k]);
    }
  }
}
inline void setSaturations_16(T_KI K){
  _KRR_16 = _m_coef_R_R_16[K];
  _KRG_16 = _m_coef_R_G_16[K];
  _KRB_16 = _m_coef_R_B_16[K];
  _KGR_16 = _m_coef_G_R_16[K];
  _KGG_16 = _m_coef_G_G_16[K];
  _KBB_16 = _m_coef_B_B_16[K];
}
inline __sat_t coef_R_Ro_16(T_C R, __sat_t* K){ return K[R];}
inline __sat_t coef_R_Go_16(T_C G, __sat_t* K){ return K[G];}
inline __sat_t coef_R_Bo_16(T_C B, __sat_t* K){ return K[B];}
inline __sat_t coef_G_Ro_16(T_C R, __sat_t* K){ return K[R];}
inline __sat_t coef_G_Go_16(T_C G, __sat_t* K){ return K[G];}
inline __sat_t coef_B_Bo_16(T_C B, __sat_t* K){ return K[B];}
inline T_C SaturateRo_16(T_C R, T_C G, T_C B, __sat_t* KRR, __sat_t* KRG, __sat_t* KRB){
  int result =  (coef_R_Ro_16(R,KRR)+coef_R_Go_16(G,KRG)+coef_R_Bo_16(B,KRB))>>(10-SAT_SHIFT);
  return (T_C)min(MAX_CS,max(0,result));
}
inline T_C SaturateGo_16(T_C R, T_C G, T_C B, __sat_t* KGR, __sat_t* KGG, __sat_t* KRB){
  int result =  (coef_G_Ro_16(R,KGR)+coef_G_Go_16(G,KGG)+coef_R_Bo_16(B,KRB))>>(10-SAT_SHIFT);
  return (T_C)min(MAX_CS,max(0,result));
}
inline T_C SaturateBo_16(T_C R, T_C G, __u8 B, __sat_t* KGR, __sat_t* KRG, __sat_t* KBB){
  int result =  (coef_G_Ro_16(R,KGR)+coef_R_Go_16(G,KRG)+coef_B_Bo_16(B,KBB))>>(10-SAT_SHIFT);
  return (T_C)min(MAX_CS,max(0,result));
}
#else
inline void setSaturations_16(T_K K){}
void initSaturation_16(void){}
inline __sat_t coef_R_R_16(T_C R, T_K K){ return ((292l+(685l*K)/SAT_MED)*R)>>SAT_SHIFT;}
inline __sat_t coef_R_G_16(T_C G, T_K K){ return ((573l*(SAT_MED-K)*G)/SAT_MED)>>SAT_SHIFT;}
inline __sat_t coef_R_B_16(T_C B, T_K K){ return ((111l*(SAT_MED-K)*B)/SAT_MED)>>SAT_SHIFT;}
inline __sat_t coef_G_R_16(T_C R, T_K K){ return (292l*(SAT_MED-K)*R/SAT_MED)>>SAT_SHIFT;}
inline __sat_t coef_G_G_16(T_C G, T_K K){ return ((573l+403l*K/SAT_MED)*G)>>SAT_SHIFT;}
inline __sat_t coef_G_B_16(T_C B, T_K K){ return (111l*(SAT_MED-K)*B/SAT_MED)>>SAT_SHIFT;}
inline __sat_t coef_B_R_16(T_C R, T_K K){ return (292l*(SAT_MED-K)*R/SAT_MED)>>SAT_SHIFT;}
inline __sat_t coef_B_G_16(T_C G, T_K K){ return ((573l*(SAT_MED-K))*G/SAT_MED)>>SAT_SHIFT;}
inline __sat_t coef_B_B_16(T_C B, T_K K){ return ((111l+865l*K/SAT_MED)*B)>>SAT_SHIFT;}
inline T_C SaturateR_16(T_C R, T_C G, T_C B, T_K K){
  int result =  (coef_R_R(R,K)+coef_R_G(G,K)+coef_R_B(B,K))>>(10-SAT_SHIFT);
  return (T_C)min(MAX_CS,max(0,result));
}
inline T_C SaturateG_16(T_C R, T_C G, T_C B, T_K K){
  int result =  (coef_G_R(R,K)+coef_G_G(G,K)+coef_G_B(B,K))>>(10-SAT_SHIFT);
  return (T_C)min(MAX_CS,max(0,result));
}
inline T_C SaturateB_16(T_C R, T_C G, T_C B, T_K K){
  int result =  (coef_B_R(R,K)+coef_B_G(G,K)+coef_B_B(B,K))>>(10-SAT_SHIFT);
  return (T_C)min(MAX_CS,max(0,result));
} 
#endif
#define _LE_CPU(a) __le16_to_cpu(a)
inline void interpolateRGBg_16(T_C*R, T_C*G, T_C*B,
			       T_C* image, int _brightness,
			       int line_prev, int pix_prev,
			       int line_next, int pix_next,
			       int src_ptr, int line_start, int w,
			       int red, int green, int blue,
			       int evenh, int evenw,
			       const T_G * crt_gamma,
			       struct sentech_camera* cam_data, int h) {
  int saturation = cam_data->saturation;;
  if(!color_correction){
    if(evenh)
      if(evenw){ 
	*R = crt_gamma[_LE_CPU(image[src_ptr])];
	*G = crt_gamma[(((__u16)0)+_LE_CPU(image[line_prev+w])+_LE_CPU(image[line_next+w])+
			_LE_CPU(image[line_start+pix_prev])+
			_LE_CPU(image[line_start+pix_next]))>>2];
	*B = crt_gamma[(((__u16)0)+_LE_CPU(image[line_prev+pix_prev])+
			_LE_CPU(image[line_prev+pix_next])+
			_LE_CPU(image[line_next+pix_prev])+
			_LE_CPU(image[line_next+pix_next]))>>2];
      }else{     
	*R = crt_gamma[(((__u16)0)+_LE_CPU(image[line_start+pix_prev])+
			_LE_CPU(image[line_start+pix_next]))>>1];
	*G = crt_gamma[_LE_CPU(image[src_ptr])];
	*B = crt_gamma[(((__u16)0)+
			_LE_CPU(image[line_prev+w])+
			_LE_CPU(image[line_next+w]))>>1];
      }
    else
      if(evenw){ 
	*B = crt_gamma[(((__u16)0)+_LE_CPU(image[line_start+pix_prev])+
			_LE_CPU(image[line_start+pix_next]))>>1];
	*G = crt_gamma[_LE_CPU(image[src_ptr])];
	*R = crt_gamma[(((__u16)0)+_LE_CPU(image[line_prev+w])+
			_LE_CPU(image[line_next+w]))>>1];
      }else{     
	*R = crt_gamma[(((__u16)0)+_LE_CPU(image[line_prev+pix_prev])+
			_LE_CPU(image[line_prev+pix_next])+
			_LE_CPU(image[line_next+pix_prev])+
			_LE_CPU(image[line_next+pix_next]))>>2];
	*G = crt_gamma[(((__u16)0)+_LE_CPU(image[line_prev+w])+_LE_CPU(image[line_next+w])+
			_LE_CPU(image[line_start+pix_prev])+
			_LE_CPU(image[line_start+pix_next]))>>2];
	*B = crt_gamma[_LE_CPU(image[src_ptr])];
      }
  }else{
    if(evenh)
      if(evenw){ 
	*R = crt_gamma[norm_rgb_16(_LE_CPU(image[src_ptr]), red)];
	*B = crt_gamma[norm_rgb_16((0l+_LE_CPU(image[line_prev+pix_prev])+
				 _LE_CPU(image[line_prev+pix_next])+
				 _LE_CPU(image[line_next+pix_prev])+
				 _LE_CPU(image[line_next+pix_next]))>>2, 
				blue)];
	*G = crt_gamma[norm_rgb_16((0l+_LE_CPU(image[line_prev+w])+_LE_CPU(image[line_next+w])+
				 _LE_CPU(image[line_start+pix_prev])+
				 _LE_CPU(image[line_start+pix_next]))>>2, 
				green)];
      }else{     
	*G = crt_gamma[norm_rgb_16(_LE_CPU(image[src_ptr]),green)];
	*R = crt_gamma[norm_rgb_16((0l+_LE_CPU(image[line_start+pix_prev])+
				 _LE_CPU(image[line_start+pix_next]))>>1,
				red)];
	*B = crt_gamma[norm_rgb_16((0l+_LE_CPU(image[line_prev+w])+
				 _LE_CPU(image[line_next+w]))>>1,
				blue)];
      }
    else
      if(evenw){ 
	*G = crt_gamma[norm_rgb_16(_LE_CPU(image[src_ptr]),green)];
	*B = crt_gamma[norm_rgb_16((0l+_LE_CPU(image[line_start+pix_prev])+
				 _LE_CPU(image[line_start+pix_next]))>>1,
				blue)];
	*R = crt_gamma[norm_rgb_16((0l+_LE_CPU(image[line_prev+w])+
				 _LE_CPU(image[line_next+w]))>>1,
				red)];
      }else{     
	*B = crt_gamma[norm_rgb_16(_LE_CPU(image[src_ptr]),blue)];
	*R = crt_gamma[norm_rgb_16((0l+_LE_CPU(image[line_prev+pix_prev])+
				 _LE_CPU(image[line_prev+pix_next])+
				 _LE_CPU(image[line_next+pix_prev])+
				 _LE_CPU(image[line_next+pix_next]))>>2,
				red)];
	*G = crt_gamma[norm_rgb_16((0l+_LE_CPU(image[line_prev+w])+
				 _LE_CPU(image[line_next+w])+
				 _LE_CPU(image[line_start+pix_prev])+
				 _LE_CPU(image[line_start+pix_next]))>>2,
				green)];  
    }
  }
;
  if(cfg_saturation||(saturation != SATDEF)){
    __u8 Rs,Gs,Bs;
#ifdef EXPENSIVE_SAT
    Rs = SaturateR_16(*R,*G,*B,saturation);
    Gs = SaturateG_16(*R,*G,*B,saturation);
    Bs = SaturateB_16(*R,*G,*B,saturation);
#else
    Rs = SaturateRo_16(*R,*G,*B, _KRR_16, _KRG_16, _KRB_16);
    Gs = SaturateGo_16(*R,*G,*B, _KGR_16, _KGG_16, _KRB_16);
    Bs = SaturateBo_16(*R,*G,*B, _KGR_16, _KRG_16, _KBB_16);
#endif
    *R=Rs;
    *G=Gs;
    *B=Bs;
  };
  if(brightness_correction){
    *R = norm_rgb_bright_16(*R,_brightness);
    *G = norm_rgb_bright_16(*G,_brightness);
    *B = norm_rgb_bright_16(*B,_brightness);
  };
}
inline void interpolateRGB_16(T_C*R, T_C*G, T_C*B,
			   T_C* image, int _brightness,
			   int line_prev, int pix_prev,
			   int line_next, int pix_next,
			   int src_ptr, int line_start, int w,
			   int red, int green, int blue,
			   int evenh, int evenw,
			      struct sentech_camera* cam_data) {
  T_C Rs,Gs,Bs;
  const T_G *crt_gamma = sentech_gamma16[cam_data->gamma];
  if(evenh)
    if(evenw){ 
      *R = norm_rgb_16(_LE_CPU(image[src_ptr]), red);
      *B = norm_rgb_16((0l+_LE_CPU(image[line_prev+pix_prev])+
		     _LE_CPU(image[line_prev+pix_next])+
		     _LE_CPU(image[line_next+pix_prev])+
		     _LE_CPU(image[line_next+pix_next]))>>2, blue);
      *G = norm_rgb_16((0l+_LE_CPU(image[line_prev+w])+
		     _LE_CPU(image[line_next+w])+
		     _LE_CPU(image[line_start+pix_prev])+
		     _LE_CPU(image[line_start+pix_next]))>>2, green);
    }else{     
      *G = norm_rgb_16(_LE_CPU(image[src_ptr]),green);
      *R = norm_rgb_16((0l+_LE_CPU(image[line_start+pix_prev])+
		     _LE_CPU(image[line_start+pix_next]))>>1, red);
      *B = norm_rgb_16((0l+_LE_CPU(image[line_prev+w])+_LE_CPU(image[line_next+w]))>>1, blue);
    }
  else
    if(evenw){ 
      *G = norm_rgb_16(_LE_CPU(image[src_ptr]),green);
      *B = norm_rgb_16((0l+_LE_CPU(image[line_start+pix_prev])+
		     _LE_CPU(image[line_start+pix_next]))>>1, blue);
      *R = norm_rgb_16((0l+_LE_CPU(image[line_prev+w])+
		     _LE_CPU(image[line_next+w]))>>1, red);
    }else{     
      *B = norm_rgb_16(_LE_CPU(image[src_ptr]),blue);
      *R = norm_rgb_16((0l+_LE_CPU(image[line_prev+pix_prev])+
		     _LE_CPU(image[line_prev+pix_next])+
		     _LE_CPU(image[line_next+pix_prev])+
		     _LE_CPU(image[line_next+pix_next]))>>2, red);
      *G = norm_rgb_16((0l+_LE_CPU(image[line_prev+w])+_LE_CPU(image[line_next+w])+
		     _LE_CPU(image[line_start+pix_prev])+
		     _LE_CPU(image[line_start+pix_next]))>>2, green);  
    }
#ifdef EXPENSIVE_SAT
  {
  int saturation = cam_data->saturation;
  Rs = norm_rgb_bright_16(SaturateR(crt_gamma[(*R)],crt_gamma[(*G)],crt_gamma[(*B)],saturation),_brightness);
  Gs = norm_rgb_bright_16(SaturateG(crt_gamma[(*R)],crt_gamma[(*G)],crt_gamma[(*B)],saturation),_brightness);
  Bs = norm_rgb_bright_16(SaturateB(crt_gamma[(*R)],crt_gamma[(*G)],crt_gamma[(*B)],saturation),_brightness);
  }
#else
  Rs = SaturateRo_16(crt_gamma[(*R)],crt_gamma[(*G)],crt_gamma[(*B)], _KRR_16, _KRG_16, _KRB_16);
  Gs = SaturateGo_16(crt_gamma[(*R)],crt_gamma[(*G)],crt_gamma[(*B)], _KGR_16, _KGG_16, _KRB_16);
  Bs = SaturateBo_16(crt_gamma[(*R)],crt_gamma[(*G)],crt_gamma[(*B)], _KGR_16, _KRG_16, _KBB_16);
#endif
  *R=Rs;
  *G=Gs;
  *B=Bs;
  if(brightness_correction){
    *R = norm_rgb_bright_16(*R,_brightness);
    *G = norm_rgb_bright_16(*G,_brightness);
    *B = norm_rgb_bright_16(*B,_brightness);
  }
}
union TBG{
  T_C c[2];
  T_2C c2;
};
__attribute__((always_inline)) inline void
gen_line_bgr48(struct sentech_camera *cam_data,
	       T_S* frame , T_D __user *data,
	       int max_width , int wmax ,
	       int wstart , int h ,
	       const T_G * crt_gamma) {
  int  evenh, evenw;
  int brightness = cam_data->brightness;
  int red = cam_data->red, green = cam_data->green, blue = cam_data->blue;
  int w, wmax_abs;
  int line_start = 0, line_prev = -max_width, line_next = max_width;
  T_C R; 
  union TBG BG;
  T_D __user *p=data;
  int src_ptr;
  int pix_prev, pix_next;
  if(unlikely(!h)) line_prev = line_next;
  if(unlikely(h == cam_data->scan_height)) line_next = line_prev;
  evenh = !(h & 1);
  wmax_abs = wmax+wstart-1;
  for (w=wstart+1;w<wmax_abs;w++) {
    src_ptr = line_start+w;
    pix_prev = w-1, pix_next = w+1;
    evenw = !(w & 1);
    interpolateRGBg_16(
		   &R, BG.c, BG.c+1,
		   frame, brightness,
		   line_prev, pix_prev,
		   line_next, pix_next,
		   src_ptr, line_start, w,
		   red, green, blue,
		   evenh, evenw, crt_gamma, cam_data,h);
    __put_user(BG.c2,(T_2C*)p);
    p++;
    p++;
    __put_user(R,p);
    p++;
  }
}
__attribute__((always_inline)) inline void
gen_line_rgb48(struct sentech_camera *cam_data,
	       T_S* frame , T_D __user *data,
	       int max_width , int wmax ,
	       int wstart , int h ,
		const T_G * crt_gamma
	       ) {
  int  evenh, evenw;
  int brightness = cam_data->brightness;
  int red = cam_data->red, green = cam_data->green, blue = cam_data->blue;
  int w, wmax_abs;
  int line_start = 0, line_prev = -max_width, line_next = max_width;
  T_C  B;
  union TBG RG;
  T_D __user *p=data;
  int src_ptr;
  int pix_prev, pix_next;
  if(unlikely(!h)) line_prev = line_next;
  if(unlikely(h == (cam_data->scan_height-1))) line_next = line_prev;
  evenh = !(h & 1);
  wmax_abs = wmax+wstart-1;
  for (w=wstart+1;w<wmax_abs;w++) {
    src_ptr = line_start+w;
    pix_prev = w-1, pix_next = w+1;
    evenw = !(w & 1);
    interpolateRGBg_16(
		   RG.c, RG.c+1, &B,
		   frame, brightness,
		   line_prev, pix_prev,
		   line_next, pix_next,
		   src_ptr, line_start, w,
		   red, green, blue,
		   evenh, evenw, crt_gamma, cam_data, h);
    __put_user(RG.c2,(T_2C*)p);
    p++;
    p++;
    __put_user(B,p);
    p++;
  }
}
__attribute__((always_inline)) inline void
gen_line_yuyv16(struct sentech_camera *cam_data,
	      T_S* frame , char __user *data,
	      int max_width , int wmax ,
	      int wstart , int h ,
	      const T_G * crt_gamma,
	      int max_height) {
  int  evenh, evenw;
  int brightness = cam_data->brightness;
  int red = cam_data->red, green = cam_data->green, blue = cam_data->blue;
  int w, wmax_abs;
  int line_start = 0, line_prev = -max_width, line_next = max_width;
  T_C R, G, B;
  __u8 Y, U=0, V=0;
  char __user *p=data;
  int src_ptr;
  int pix_prev, pix_next;
  int wmax1 = wstart+wmax-1;
  if(unlikely(!h)) line_prev = line_next;
  else if(unlikely(h==(max_height-1))) line_next = line_prev;
  evenh = !(h & 1);
  wmax_abs = wmax+wstart;;
  for (w=wstart;w<wmax_abs;w++) {
    src_ptr = line_start+w;;
    pix_prev = w-1; pix_next = w+1;
    if(!w) {pix_prev = pix_next;}
    else if(w == wmax1) {pix_next=pix_prev;}
    evenw = !(w & 1);;
    interpolateRGBg_16(&R, &G, &B,
		    frame, brightness,
		    line_prev, pix_prev,
		    line_next, pix_next,
		    src_ptr, line_start, w,
		    red, green, blue,
		       evenh, evenw, crt_gamma, cam_data,h);    
    Y = TO_Y(R,G,B)>>B_CS;
    __put_user(Y,p);
    p++;
    if(evenw){
      U=TO_U_16(R,G,B)>>B_CS;
      __put_user(U,p);;
    }else{
      V=TO_V_16(R,G,B)>>B_CS;
      __put_user(V,p);;
    }
    p++;
  }
}
static int 
move_sub_to_user16(struct sentech_usb_buffer* sub,
		 char __user *_data,
		 size_t count) {
  T_D __user* data = (T_D __user* )_data;
  struct sentech_camera* cam_data = sub->cam_data;
  struct sentech_usb_fragment* suf;
  int row, rows=0;
  unsigned int transfer=0; 
  unsigned int size; 
  int idx=0;  
  int i, retval = 0;
  int bytes_read=0;
  int inc;  
  int pix_w_dest;  
  int hratio=1;
  int rows_output;
  int real_fragment_size;
  unsigned int offset;
  T_S* lptr;
  const T_G * crt_gamma = sentech_gamma16[cam_data->gamma];;
  if(!access_ok(VERIFY_WRITE, (void __user*)data, count)){;
    return -EFAULT;
  }
  if((cam_data->pix_format.sizeimage > count)&&
     (count % cam_data->pix_format.bytesperline == 0)) {
    cam_data->pix_format.height=cam_data->crop.height =cam_data->height=cam_data->output.height = count / cam_data->pix_format.bytesperline;
    cam_data->output.top=1;
    cam_data->pix_format.sizeimage = cam_data->pix_format.bytesperline*cam_data->height;
  }
  if(cam_data->pix_format.sizeimage > count) {;
    return -EINVAL;
  }
  pix_w_dest=(param_old_scale)?cam_data->crop.width:cam_data->output.width;
  hratio = (param_old_scale)?1:cam_data->output.top;
  if(hratio<1) hratio=1;
  if(cam_data->output.left!=1) {
    cam_data->output.left=1;
    cam_data->crop.width = cam_data->output.width;;
  }
  switch(cam_data->fmt->fourcc){
  case V4L2_PIX_FMT_GREY:
  case V4L2_PIX_FMT_SRGGB8:
  case V4L2_PIX_FMT_SGRBG8:
    inc=pix_w_dest;
    if(hratio!=1) {
      hratio = 1;
      cam_data->output.top = 1;
      cam_data->crop.height = cam_data->output.height;
    }
    if (param_bytesperline || 
	(cam_data->max_width == ((unsigned)pix_w_dest))) {
      offset = cam_data->crop.top * cam_data->max_width + cam_data->crop.left;
      size = cam_data->crop.height * cam_data->max_width;
      list_for_each_entry(suf, &sub->suf_buffers, buffers) {
	real_fragment_size = suf->fragment_size;
	if(suf->first_suf) real_fragment_size += sizeof(struct Sentech_Header);
	if(offset >= real_fragment_size) {
	  offset -= real_fragment_size;
	  continue;
	}
	if(size<=0) break;
	transfer = real_fragment_size-offset;
	if(size < transfer) transfer = size;
	if (__copy_to_user(data, suf->framebuffer_image+offset,
			   transfer)){;
	  retval = -EFAULT;
	  break;
	}else{
	  bytes_read += transfer; 
	  data += transfer; 
	  retval = bytes_read;
	  size -= transfer; 
	  offset = 0;
	}
      }
      return retval;
    }
    row = cam_data->crop.top;
    transfer=cam_data->crop.left;
    transfer += row * cam_data->max_width;
    list_for_each_entry(suf, &sub->suf_buffers, buffers) {;
      real_fragment_size = suf->fragment_size;
      if(suf->first_suf) real_fragment_size += sizeof(struct Sentech_Header);
      for(; rows<cam_data->crop.height;
	  row++, rows++) {
	if(transfer >= real_fragment_size){
	  transfer -= real_fragment_size;
	  break;
	}
	idx = transfer;
	if (real_fragment_size-transfer < ((unsigned)cam_data->crop.width)) {
	  size = real_fragment_size-transfer;
	} else {
	  size = cam_data->crop.width;
	  transfer += cam_data->max_width;
	}
	if(count < bytes_read+size) {;
	  retval = -EFAULT;
	  break;
	}
	if (copy_to_user(data, 
			 suf->framebuffer_image+idx, 
			 size)){;
	  retval = -EFAULT;
	  break;
	}else{
	  bytes_read += size;
	  data += size;
	  retval = bytes_read;;
	}
      }
      if (retval == -EFAULT) break;
    }
    break;
  case V4L2_PIX_FMT_SBGGR8:;
    if(!param_old_scale){;
      break;
    }
    if (param_bytesperline) {
      offset = (cam_data->crop.top+1) * cam_data->max_width + cam_data->crop.left + 1;
      size = cam_data->crop.height * cam_data->max_width;
      list_for_each_entry(suf, &sub->suf_buffers, buffers) {
	if(offset >= suf->fragment_size) {
	  offset -= suf->fragment_size;
	  continue;
	}
	if(size<=0) break;
	transfer = suf->fragment_size-offset;
	if(size < transfer) transfer = size;
	if (__copy_to_user(data, suf->framebuffer_image+offset,
			   transfer)){;
	  retval = -EFAULT;
	  break;
	}else{
	  bytes_read += suf->fragment_size;
	  data += suf->fragment_size;
	  retval = bytes_read;
	  size -= suf->fragment_size-offset;
	  offset = 0;
	}
      }
      return retval;
    }
    row = cam_data->crop.top+1;
    transfer=cam_data->crop.left+1;
    transfer += row * cam_data->max_width;
    list_for_each_entry(suf, &sub->suf_buffers, buffers) {;
      for(; rows<cam_data->crop.height;
	  row++, rows++) {
	if(transfer >= suf->fragment_size){
	  transfer -= suf->fragment_size;
	  break;
	}
	idx = transfer;
	if (suf->fragment_size-transfer < ((unsigned)cam_data->crop.width)) {
	  size = suf->fragment_size-transfer;
	} else {
	  size = cam_data->crop.width;
	  transfer += cam_data->max_width;
	}
	if(count < bytes_read+size) {;
	  retval = -EFAULT;
	  break;
	}
	if (__copy_to_user(data, 
			 suf->framebuffer_image+idx, 
			 size)){;
	  retval = -EFAULT;
	  break;
	}else{
	  bytes_read += size;
	  data += size;
	  retval = bytes_read;
	}
      }
      if (retval == -EFAULT) break;
    }
    break;
  case V4L2_PIX_FMT_BGR48:;;
    if(param_old_scale)
      inc = cam_data->crop.width;
    else
      inc = cam_data->output.width;
    inc += (inc <<1);
    suf = first_suf(sub);
    row = cam_data->crop.top;
    lptr = ((T_S*)suf->framebuffer_image) + 
		  row*cam_data->max_width;
    hratio = cam_data->output.top;
    if(hratio<1) hratio=1;
    rows_output = (param_old_scale)?
      cam_data->crop.height:
      cam_data->output.height;
    for (rows=0;rows<rows_output;row+=hratio, rows++) {
      if(retval+inc>count) break;
      gen_line_bgr48(cam_data, 
		     lptr, data, 
		     cam_data->max_width, 
		     (param_old_scale?cam_data->crop.width:cam_data->output.width),
		     cam_data->crop.left, row, crt_gamma);
      data += inc;
      retval += inc;
      lptr += cam_data->max_width;
    }
    break;
  case V4L2_PIX_FMT_RGB48:;;
    if(param_old_scale)
      inc = cam_data->crop.width;
    else
      inc = cam_data->output.width;
    inc += (inc <<1);
    suf = first_suf(sub);
    row = cam_data->crop.top;
    lptr = ((T_S*)suf->framebuffer_image) + 
      row*cam_data->max_width;
    hratio = cam_data->output.top;
    if(hratio<1) hratio=1;
    rows_output = (param_old_scale)?
      cam_data->crop.height:
      cam_data->output.height;
    for (rows=0;rows<rows_output;row+=hratio, rows++) {
      if(retval+inc>count) break;
      gen_line_rgb48(cam_data, 
		     lptr, data, 
		     cam_data->max_width,
		     (param_old_scale?cam_data->crop.width:cam_data->output.width),
		     cam_data->crop.left, row, crt_gamma);
      data += inc;
      retval += inc;
      lptr += cam_data->max_width;
    }
    break;
  case V4L2_PIX_FMT_YUYV:;;
    if(param_old_scale){
      inc = cam_data->crop.width << 1;;
    }else{
      inc = cam_data->output.width << 1;;
    }
    suf = first_suf(sub);
    row = cam_data->crop.top;
    lptr = ((T_D*)suf->framebuffer_image) + 
      row*cam_data->max_width;
    hratio = cam_data->output.top;
    if(hratio<1) hratio=1;
    rows_output = (param_old_scale)?
      cam_data->crop.height:
      cam_data->output.height;;
    for (rows=0; rows<rows_output; row+=hratio, rows++) {
      if(retval+inc>count) break;;
      gen_line_yuyv16(cam_data, 
		      lptr, _data, 
		      cam_data->max_width, 
		      (param_old_scale?cam_data->crop.width:cam_data->output.width),
		      cam_data->crop.left, row, crt_gamma,
		      cam_data->max_height);
      _data += inc;
      if(0){
	for(i=0; i< cam_data->crop.width; i++, _data++) {
	  __put_user(0x80,_data);
	  __put_user(0x80,_data);
	}
      }
      if(0){
	for(i=0; i< cam_data->crop.width; i++, _data++) {
	  __put_user(0,_data);
	  __put_user(0,_data);
	}
      }
      retval += inc;
      lptr += cam_data->max_width;
    };
    break;    
  default:;
    retval=0;
  }
  return retval;
}
